compile.sh 5.74 KB
Newer Older
Rémi Duraffort's avatar
Rémi Duraffort committed
1 2
#! /bin/sh

Jean-Baptiste Kempf's avatar
Jean-Baptiste Kempf committed
3 4 5
# Read the Android Wiki http://wiki.videolan.org/AndroidCompile
# Setup all that stuff correctly.
# Get the latest Android SDK Platform or modify numbers in configure.sh and vlc-android/default.properties.
Rafaël Carré's avatar
Rafaël Carré committed
6

7 8
set -e

9 10 11 12
if [ -z "$ANDROID_NDK" -o -z "$ANDROID_SDK" -o -z "$ANDROID_ABI" ]; then
   echo "You must define ANDROID_NDK, ANDROID_SDK and ANDROID_ABI before starting."
   echo "They must point to your NDK and SDK directories.\n"
   echo "ANDROID_ABI should match your ABI: armeabi-v7a, armeabi or ..."
Rafaël Carré's avatar
Rafaël Carré committed
13 14
   exit 1
fi
15 16 17

export ANDROID_HOME=$ANDROID_SDK

Rafaël Carré's avatar
Rafaël Carré committed
18 19 20 21
# try to detect NDK version
REL=$(grep -o '^r[0-9]*.*' $ANDROID_NDK/RELEASE.TXT 2>/dev/null|cut -b2-)
case "$REL" in
    8?)
Sébastien Toque's avatar
Sébastien Toque committed
22
        # NDK >= v8b, both 4.4.3 and 4.6 available,
23 24 25
        # we use 4.6 because 4.4.3 doesn't handle threads correctly.
        GCCVER=4.6
        CXXSTL="/4.6"
Rafaël Carré's avatar
Rafaël Carré committed
26
    ;;
27 28
    7|8|*)
        echo "You need the NDKv8b or later"
Rafaël Carré's avatar
Rafaël Carré committed
29 30 31 32 33 34
        exit 1
    ;;
esac

export GCCVER
export CXXSTL
Rémi Duraffort's avatar
Rémi Duraffort committed
35

36 37 38 39
# XXX : important!
cat << EOF
For an ARMv6 device without FPU, you need a build without FPU:
$ export NO_FPU=1
Edward Wang's avatar
Edward Wang committed
40 41
For an ARMv5 device or the Android emulator, you need an ARMv5 build:
$ export NO_ARMV6=1
42 43 44

If you plan to use a release build, run 'compile.sh release'
EOF
45

Edward Wang's avatar
Edward Wang committed
46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62
# Set up ABI variables
if [ ${ANDROID_ABI} = "x86" ] ; then
    TARGET_TUPLE="i686-android-linux"
    PATH_HOST="x86"
    HAVE_X86=1
    PLATFORM_SHORT_ARCH="x86"
elif [ ${ANDROID_ABI} = "mips" ] ; then
    TARGET_TUPLE="mipsel-linux-android"
    PATH_HOST=$TARGET_TUPLE
    HAVE_MIPS=1
    PLATFORM_SHORT_ARCH="mips"
else
    TARGET_TUPLE="arm-linux-androideabi"
    PATH_HOST=$TARGET_TUPLE
    HAVE_ARM=1
    PLATFORM_SHORT_ARCH="arm"
fi
63 64 65 66 67 68 69 70 71 72 73 74 75

if [ ${ANDROID_ABI} = "x86" ] ; then
    # x86 toolchain location changes in NDK r8b
    case "$REL" in
        8?)
            TARGET_TUPLE="i686-linux-android"
        ;;
        *)
            TARGET_TUPLE="i686-android-linux"
        ;;
    esac
fi

Edward Wang's avatar
Edward Wang committed
76 77 78 79 80 81 82
export TARGET_TUPLE
export PATH_HOST
export HAVE_ARM
export HAVE_X86
export HAVE_MIPS
export PLATFORM_SHORT_ARCH

83 84
# Add the NDK toolchain to the PATH, needed both for contribs and for building
# stub libraries
Rafaël Carré's avatar
Rafaël Carré committed
85
export PATH=${ANDROID_NDK}/toolchains/${PATH_HOST}-${GCCVER}/prebuilt/`uname|tr A-Z a-z`-x86/bin:${PATH}
86

Rafaël Carré's avatar
Rafaël Carré committed
87
# 1/ libvlc, libvlccore and its plugins
Jean-Baptiste Kempf's avatar
Jean-Baptiste Kempf committed
88
TESTED_HASH=826ec51f
89
if [ ! -d "vlc" ]; then
90
    echo "VLC source not found, cloning"
91
    git clone git://git.videolan.org/vlc.git vlc
Philipp Dreimann's avatar
Philipp Dreimann committed
92
    cd vlc
93
    git checkout -B android ${TESTED_HASH}
94
    echo "Applying the patches"
95
    git am -3 ../patches/*.patch
96 97 98 99 100
    if [ $? -ne 0 ]; then
        git am --abort
        echo "Applying the patches failed, aborting git-am"
        exit 1
    fi
101
else
102
    echo "VLC source found"
103
    cd vlc
104 105 106 107 108 109 110
    if ! git cat-file -e ${TESTED_HASH}; then
        cat << EOF
***
*** Error: Your vlc checkout does not contain the latest tested commit ***
***

Please update your source with something like:
Rémi Duraffort's avatar
Rémi Duraffort committed
111 112

cd vlc
113 114 115
git reset --hard origin
git pull origin master
git checkout -B android ${TESTED_HASH}
Sébastien Toque's avatar
Sébastien Toque committed
116
git am -3 ../patches/*
117 118 119 120 121 122 123

*** : This will delete any changes you made to the current branch ***

EOF
        exit 1
    fi
fi
Rémi Duraffort's avatar
Rémi Duraffort committed
124

125
if [ ${ANDROID_ABI} = "armeabi-v7a" ] ; then
Jean-Baptiste Kempf's avatar
Jean-Baptiste Kempf committed
126
    EXTRA_CFLAGS="-mfpu=vfpv3-d16 -mcpu=cortex-a8"
127 128
    EXTRA_CFLAGS="${EXTRA_CFLAGS} -mthumb -mfloat-abi=softfp"
elif [ ${ANDROID_ABI} = "armeabi" ] ; then
Edward Wang's avatar
Edward Wang committed
129 130
    if [ -n "${NO_ARMV6}" ]; then
        EXTRA_CFLAGS="-march=armv5te -mtune=arm9tdmi -msoft-float"
131
    else
Edward Wang's avatar
Edward Wang committed
132 133 134 135 136
        if [ -n "${NO_FPU}" ]; then
            EXTRA_CFLAGS="-march=armv6j -mtune=arm1136j-s -msoft-float"
        else
            EXTRA_CFLAGS="-mfpu=vfp -mcpu=arm1136jf-s -mfloat-abi=softfp"
        fi
137
    fi
Edward Wang's avatar
Edward Wang committed
138 139
elif [ ${ANDROID_ABI} = "x86" ] ; then
    EXTRA_CFLAGS="-march=pentium -ffunction-sections -funwind-tables -frtti -fno-exceptions"
140 141 142
else
    echo "Unknown ABI. Die, die, die!"
    exit 2
143 144
fi

Rafaël Carré's avatar
Rafaël Carré committed
145 146 147
EXTRA_CFLAGS="${EXTRA_CFLAGS} -I${ANDROID_NDK}/sources/cxx-stl/gnu-libstdc++${CXXSTL}/include"
EXTRA_CFLAGS="${EXTRA_CFLAGS} -I${ANDROID_NDK}/sources/cxx-stl/gnu-libstdc++${CXXSTL}/libs/${ANDROID_ABI}/include"

148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166
echo "Building the contribs"
mkdir -p contrib/android
cd contrib/android
../bootstrap --host=${TARGET_TUPLE} --disable-disc --disable-sout --enable-small \
    --disable-sdl \
    --disable-SDL_image \
    --disable-fontconfig \
    --disable-zvbi \
    --disable-kate \
    --disable-caca \
    --disable-gettext \
    --disable-mpcdec \
    --disable-upnp \
    --disable-gme \
    --disable-tremor \
    --disable-vorbis \
    --disable-sidplay2 \
    --disable-samplerate \
    --disable-faad2 \
167
    --disable-harfbuzz \
168 169 170 171
    --enable-iconv

# TODO: mpeg2, theora

Rafaël Carré's avatar
Rafaël Carré committed
172 173
# Some libraries have arm assembly which won't build in thumb mode
# We append -marm to the CFLAGS of these libs to disable thumb mode
Rafaël Carré's avatar
Rafaël Carré committed
174
[ ${ANDROID_ABI} = "armeabi-v7a" ] && echo "NOTHUMB := -marm" >> config.mak
Rafaël Carré's avatar
Rafaël Carré committed
175

176
# Release or not?
177
if [ $# -ne 0 ] && [ "$1" == "release" ]; then
178
    OPTS=""
179 180
    EXTRA_CFLAGS="${EXTRA_CFLAGS} -DNDEBUG "
    RELEASEFLAG="RELEASE=1"
181 182 183 184
else
    OPTS="--enable-debug"
fi

185 186 187 188 189 190
MAKEFLAGS=
if which nproc >/dev/null
then
MAKEFLAGS=-j`nproc`
fi

191
echo "EXTRA_CFLAGS= -g ${EXTRA_CFLAGS}" >> config.mak
Jean-Baptiste Kempf's avatar
Jean-Baptiste Kempf committed
192
export VLC_EXTRA_CFLAGS="${EXTRA_CFLAGS}"
193

Rafaël Carré's avatar
Rafaël Carré committed
194
make fetch
195
make $MAKEFLAGS
Rémi Duraffort's avatar
Rémi Duraffort committed
196 197 198

cd ../.. && mkdir -p android && cd android

199
if test ! -s "../configure" ; then
Jean-Baptiste Kempf's avatar
Jean-Baptiste Kempf committed
200
    echo "Bootstraping"
Sébastien Toque's avatar
Sébastien Toque committed
201
    ../bootstrap
Rafaël Carré's avatar
Rafaël Carré committed
202
fi
Rémi Duraffort's avatar
Rémi Duraffort committed
203 204

echo "Configuring"
205
../../configure.sh $OPTS
Rémi Duraffort's avatar
Rémi Duraffort committed
206

Jean-Baptiste Kempf's avatar
Jean-Baptiste Kempf committed
207
echo "Building"
208
make $MAKEFLAGS
Jean-Baptiste Kempf's avatar
Jean-Baptiste Kempf committed
209

Rafaël Carré's avatar
Rafaël Carré committed
210 211 212

# 2/ VLC android UI and specific code

Jean-Baptiste Kempf's avatar
Jean-Baptiste Kempf committed
213 214
echo "Building Android"
cd ../../
Rafaël Carré's avatar
Rafaël Carré committed
215

216
export ANDROID_SYS_HEADERS_GINGERBREAD=${PWD}/android-headers-gingerbread
217
export ANDROID_SYS_HEADERS_HC=${PWD}/android-headers-hc
218
export ANDROID_SYS_HEADERS_ICS=${PWD}/android-headers-ics
Rafaël Carré's avatar
Rafaël Carré committed
219 220

export ANDROID_LIBS=${PWD}/android-libs
221
export VLC_BUILD_DIR=vlc/android
Rafaël Carré's avatar
Rafaël Carré committed
222

Jean-Baptiste Kempf's avatar
Jean-Baptiste Kempf committed
223
make distclean
224
make -j1 TARGET_TUPLE=$TARGET_TUPLE PLATFORM_SHORT_ARCH=$PLATFORM_SHORT_ARCH CXXSTL=$CXXSTL $RELEASEFLAG